<nz-card 
    class="users-cont"
    nzTitle="Users">
    <nz-table 
        #usersTable 
        [nzData]="users" 
        nzPageSize="10"
        [nzLoading]="isLoading">
        <thead>
            <tr>
                <th>UUID</th>
                <th nzCustomFilter>
                    Name
                    <i
                        nz-th-extra
                        class="ant-table-filter-icon"
                        #dropdown="nzDropdown"
                        nzTableFilter
                        nz-icon
                        nz-dropdown
                        [nzDropdownMenu]="menu"
                        nzType="search"                        
                        nzTrigger="click"
                        nzPlacement="bottomRight"
                        [nzClickHide]="false"
                        [class.ant-table-filter-open]="dropdown.nzVisible">
                    </i>
                </th>
                <th>Username</th>
                <th>Email</th>
            </tr>
        </thead>
        <tbody>
            <tr 
                *ngFor="let user of usersTable.data | nameFilter : searchInput;"
                class="cursor-pointer"
                (click)="showModal(user)">
                <td>{{ user.id }}</td>
                <td>{{ user.name }}</td>
                <td>{{ user.username }}</td>
                <td>{{ user.email }}</td>
            </tr>
        </tbody>
    </nz-table>
</nz-card>


<!-- Modal for user's posts -->
<!-- Ideally this component would be a child component -->
<!-- To wins some time, this step has been avoided -->
<nz-modal 
    class="user-posts-cont" 
    [(nzVisible)]="isVisible" 
    nzTitle="{{ selectedUser ? selectedUser.name : '' }}" 
    (nzOnCancel)="onCancel()">
    <nz-list 
        [nzDataSource]="posts" 
        [nzRenderItem]="item" 
        [nzItemLayout]="'horizontal'" 
        [nzLoading]="loading">
        <ng-template #item let-item>
            <nz-list-item class="single-post">
                <nz-list-item-meta 
                    class="cursor-pointer"
                    [nzAvatar]="icon"
                    nzTitle="{{ item.title }}"                
                    nzDescription="{{ item.body }}"
                    (click)="navigateToSelectedPost(item)">
                    <ng-template #icon>
                        <nz-avatar nzIcon="mdi:message-outline"></nz-avatar>
                    </ng-template>
                </nz-list-item-meta>
            </nz-list-item>
        </ng-template>
    </nz-list>
    <!-- Custom footer for modal -->
    <div *nzModalFooter>
        <!-- EMPTY -->
        <!-- This is doen to remove the 'Cancel' and 'Ok' buttons -->
    </div>
</nz-modal>


<!-- Dropdown for filtering on name -->
<nz-dropdown-menu #menu="nzDropdownMenu">
    <div class="search-box" fxLayout="row">
        <input 
            type="text" 
            nz-input 
            placeholder="Search name" 
            [(ngModel)]="searchInput" />
        <button 
            nz-button 
            nzSize="small" 
            (click)="reset()">
            Reset
        </button>
    </div>
</nz-dropdown-menu>